com.fasterxml.jackson.databind.deser

## Class ValueInstantiator.Delegating

- java.lang.Object
- - com.fasterxml.jackson.databind.deser.ValueInstantiator
  - - com.fasterxml.jackson.databind.deser.ValueInstantiator.Delegating

All Implemented Interfaces:
  Serializable

Enclosing class:
  ValueInstantiator

    public static class ValueInstantiator.Delegating
    extends ValueInstantiator
    implements Serializable

Delegating `ValueInstantiator` implementation meant as a base type that by default delegates methods to specified fallback instantiator.

Since:
  2.12
See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.deser.ValueInstantiator

`ValueInstantiator.Base, ValueInstantiator.Delegating, ValueInstantiator.Gettable`

### Field Summary

Fields
`protected ValueInstantiator` `_delegate`

### Constructor Summary

Constructors
`protected` `Delegating(ValueInstantiator delegate)`

### Method Summary

All Methods Instance Methods Concrete Methods
`boolean` `canCreateFromBoolean()` Method that can be called to check whether a double (boolean / Boolean) based creator is available to use (to call `ValueInstantiator.createFromDouble(com.fasterxml.jackson.databind.DeserializationContext, double)`).
`boolean` `canCreateFromDouble()` Method that can be called to check whether a double (double / Double) based creator is available to use (to call `ValueInstantiator.createFromDouble(com.fasterxml.jackson.databind.DeserializationContext, double)`).
`boolean` `canCreateFromInt()` Method that can be called to check whether an integer (int, Integer) based creator is available to use (to call `ValueInstantiator.createFromInt(com.fasterxml.jackson.databind.DeserializationContext, int)`).
`boolean` `canCreateFromLong()` Method that can be called to check whether a long (long, Long) based creator is available to use (to call `ValueInstantiator.createFromLong(com.fasterxml.jackson.databind.DeserializationContext, long)`).
`boolean` `canCreateFromObjectWith()` Method that can be called to check whether a property-based creator (argument-taking constructor or factory method) is available to instantiate values from JSON Object
`boolean` `canCreateFromString()` Method that can be called to check whether a String-based creator is available for this instantiator.
`boolean` `canCreateUsingArrayDelegate()` Method that can be called to check whether a array-delegate-based creator (single-arg constructor or factory method) is available for this instantiator
`boolean` `canCreateUsingDefault()` Method that can be called to check whether a default creator (constructor, or no-arg static factory method) is available for this instantiator
`boolean` `canCreateUsingDelegate()` Method that can be called to check whether a delegate-based creator (single-arg constructor or factory method) is available for this instantiator
`boolean` `canInstantiate()` Method that will return true if any of `canCreateXxx` method returns true: that is, if there is any way that an instance could be created.
`ValueInstantiator` `createContextual(DeserializationContext ctxt, BeanDescription beanDesc)` "Contextualization" method that is called after construction but before first use, to allow instantiator access to context needed to possible resolve its dependencies.
`Object` `createFromBigDecimal(DeserializationContext ctxt, BigDecimal value)`
`Object` `createFromBigInteger(DeserializationContext ctxt, BigInteger value)`
`Object` `createFromBoolean(DeserializationContext ctxt, boolean value)`
`Object` `createFromDouble(DeserializationContext ctxt, double value)`
`Object` `createFromInt(DeserializationContext ctxt, int value)`
`Object` `createFromLong(DeserializationContext ctxt, long value)`
`Object` `createFromObjectWith(DeserializationContext ctxt, Object[] args)` Method called to create value instance from JSON Object when instantiation arguments are passed; this is done, for example when passing information specified with "Creator" annotations.
`Object` `createFromObjectWith(DeserializationContext ctxt, SettableBeanProperty[] props, PropertyValueBuffer buffer)` Method that delegates to `ValueInstantiator.createFromObjectWith(DeserializationContext, Object[])` by default, but can be overridden if the application should have customized behavior with respect to missing properties.
`Object` `createFromString(DeserializationContext ctxt, String value)`
`Object` `createUsingArrayDelegate(DeserializationContext ctxt, Object delegate)` Method to called to create value instance from JSON Array using an intermediate "delegate" value to pass to createor method
`Object` `createUsingDefault(DeserializationContext ctxt)` Method called to create value instance from a JSON value when no data needs to passed to creator (constructor, factory method); typically this will call the default constructor of the value object.
`Object` `createUsingDelegate(DeserializationContext ctxt, Object delegate)` Method to called to create value instance from JSON Object using an intermediate "delegate" value to pass to createor method
`protected ValueInstantiator` `delegate()`
`AnnotatedWithParams` `getArrayDelegateCreator()` Method that can be called to try to access member (constructor, static factory method) that is used as the "array delegate creator".
`JavaType` `getArrayDelegateType(DeserializationConfig config)` Method that can be used to determine what is the type of array delegate type to use, if any; if no delegates are used, will return null.
`AnnotatedWithParams` `getDefaultCreator()` Method that can be called to try to access member (constructor, static factory method) that is used as the "default creator" (creator that is called without arguments; typically default [zero-argument] constructor of the type).
`AnnotatedWithParams` `getDelegateCreator()` Method that can be called to try to access member (constructor, static factory method) that is used as the "delegate creator".
`JavaType` `getDelegateType(DeserializationConfig config)` Method that can be used to determine what is the type of delegate type to use, if any; if no delegates are used, will return null.
`SettableBeanProperty[]` `getFromObjectArguments(DeserializationConfig config)` Method called to determine types of instantiation arguments to use when creating instances with creator arguments (when `ValueInstantiator.canCreateFromObjectWith()` returns true).
`Class<?>` `getValueClass()` Accessor for raw (type-erased) type of instances to create.
`String` `getValueTypeDesc()` Method that returns description of the value type this instantiator handles.
`AnnotatedWithParams` `getWithArgsCreator()` Method that can be called to try to access member (constructor, static factory method) that is used as the "non-default creator" (constructor or factory method that takes one or more arguments).

### Methods inherited from class com.fasterxml.jackson.databind.deser.ValueInstantiator

`_createFromStringFallbacks, canCreateFromBigDecimal, canCreateFromBigInteger, createUsingDefaultOrWithoutArguments`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _delegate

    protected final ValueInstantiator _delegate

### Constructor Detail

#### Delegating

    protected Delegating(ValueInstantiator delegate)

### Method Detail

#### createContextual

    public ValueInstantiator createContextual(DeserializationContext ctxt,
                                              BeanDescription beanDesc)
                                       throws JsonMappingException

Description copied from class: `ValueInstantiator`
"Contextualization" method that is called after construction but before first use, to allow instantiator access to context needed to possible resolve its dependencies.

Overrides:
  `createContextual` in class `ValueInstantiator`
Parameters:
  `ctxt` - Currently active deserialization context: needed to (for example) resolving `TypeDeserializer`s.
Returns:
  This instance, if no change, or newly constructed instance
Throws:
  `JsonMappingException` - If there are issues with contextualization

#### delegate

    protected ValueInstantiator delegate()

#### getValueClass

    public Class<?> getValueClass()

Description copied from class: `ValueInstantiator`
Accessor for raw (type-erased) type of instances to create.

NOTE: since this method has not existed since beginning of Jackson 2.0 series, default implementation will just return `Object.class`; implementations are expected to override it with real value.

Overrides:
  `getValueClass` in class `ValueInstantiator`

#### getValueTypeDesc

    public String getValueTypeDesc()

Description copied from class: `ValueInstantiator`
Method that returns description of the value type this instantiator handles. Used for error messages, diagnostics.

Overrides:
  `getValueTypeDesc` in class `ValueInstantiator`

#### canInstantiate

    public boolean canInstantiate()

Description copied from class: `ValueInstantiator`
Method that will return true if any of `canCreateXxx` method returns true: that is, if there is any way that an instance could be created.

Overrides:
  `canInstantiate` in class `ValueInstantiator`

#### canCreateFromString

    public boolean canCreateFromString()

Description copied from class: `ValueInstantiator`
Method that can be called to check whether a String-based creator is available for this instantiator.

NOTE: does NOT include possible case of fallbacks, or coercion; only considers explicit creator.

Overrides:
  `canCreateFromString` in class `ValueInstantiator`

#### canCreateFromInt

    public boolean canCreateFromInt()

Description copied from class: `ValueInstantiator`
Method that can be called to check whether an integer (int, Integer) based creator is available to use (to call `ValueInstantiator.createFromInt(com.fasterxml.jackson.databind.DeserializationContext, int)`).

Overrides:
  `canCreateFromInt` in class `ValueInstantiator`

#### canCreateFromLong

    public boolean canCreateFromLong()

Description copied from class: `ValueInstantiator`
Method that can be called to check whether a long (long, Long) based creator is available to use (to call `ValueInstantiator.createFromLong(com.fasterxml.jackson.databind.DeserializationContext, long)`).

Overrides:
  `canCreateFromLong` in class `ValueInstantiator`

#### canCreateFromDouble

    public boolean canCreateFromDouble()

Description copied from class: `ValueInstantiator`
Method that can be called to check whether a double (double / Double) based creator is available to use (to call `ValueInstantiator.createFromDouble(com.fasterxml.jackson.databind.DeserializationContext, double)`).

Overrides:
  `canCreateFromDouble` in class `ValueInstantiator`

#### canCreateFromBoolean

    public boolean canCreateFromBoolean()

Description copied from class: `ValueInstantiator`
Method that can be called to check whether a double (boolean / Boolean) based creator is available to use (to call `ValueInstantiator.createFromDouble(com.fasterxml.jackson.databind.DeserializationContext, double)`).

Overrides:
  `canCreateFromBoolean` in class `ValueInstantiator`

#### canCreateUsingDefault

    public boolean canCreateUsingDefault()

Description copied from class: `ValueInstantiator`
Method that can be called to check whether a default creator (constructor, or no-arg static factory method) is available for this instantiator

Overrides:
  `canCreateUsingDefault` in class `ValueInstantiator`

#### canCreateUsingDelegate

    public boolean canCreateUsingDelegate()

Description copied from class: `ValueInstantiator`
Method that can be called to check whether a delegate-based creator (single-arg constructor or factory method) is available for this instantiator

Overrides:
  `canCreateUsingDelegate` in class `ValueInstantiator`

#### canCreateUsingArrayDelegate

    public boolean canCreateUsingArrayDelegate()

Description copied from class: `ValueInstantiator`
Method that can be called to check whether a array-delegate-based creator (single-arg constructor or factory method) is available for this instantiator

Overrides:
  `canCreateUsingArrayDelegate` in class `ValueInstantiator`

#### canCreateFromObjectWith

    public boolean canCreateFromObjectWith()

Description copied from class: `ValueInstantiator`
Method that can be called to check whether a property-based creator (argument-taking constructor or factory method) is available to instantiate values from JSON Object

Overrides:
  `canCreateFromObjectWith` in class `ValueInstantiator`

#### getFromObjectArguments

    public SettableBeanProperty[] getFromObjectArguments(DeserializationConfig config)

Description copied from class: `ValueInstantiator`
Method called to determine types of instantiation arguments to use when creating instances with creator arguments (when `ValueInstantiator.canCreateFromObjectWith()` returns true). These arguments are bound from JSON, using specified property types to locate deserializers.

NOTE: all properties will be of type `CreatorProperty`.

Overrides:
  `getFromObjectArguments` in class `ValueInstantiator`

#### getDelegateType

    public JavaType getDelegateType(DeserializationConfig config)

Description copied from class: `ValueInstantiator`
Method that can be used to determine what is the type of delegate type to use, if any; if no delegates are used, will return null. If non-null type is returned, deserializer will bind JSON into specified type (using standard deserializer for that type), and pass that to instantiator.

Overrides:
  `getDelegateType` in class `ValueInstantiator`

#### getArrayDelegateType

    public JavaType getArrayDelegateType(DeserializationConfig config)

Description copied from class: `ValueInstantiator`
Method that can be used to determine what is the type of array delegate type to use, if any; if no delegates are used, will return null. If non-null type is returned, deserializer will bind JSON into specified type (using standard deserializer for that type), and pass that to instantiator.

Overrides:
  `getArrayDelegateType` in class `ValueInstantiator`

#### createUsingDefault

    public Object createUsingDefault(DeserializationContext ctxt)
                              throws IOException

Description copied from class: `ValueInstantiator`
Method called to create value instance from a JSON value when no data needs to passed to creator (constructor, factory method); typically this will call the default constructor of the value object. It will only be used if more specific creator methods are not applicable; hence "default".

This method is called if `ValueInstantiator.getFromObjectArguments(com.fasterxml.jackson.databind.DeserializationConfig)` returns null or empty List.

Overrides:
  `createUsingDefault` in class `ValueInstantiator`
Throws:
  `IOException`

#### createFromObjectWith

    public Object createFromObjectWith(DeserializationContext ctxt,
                                       Object[] args)
                                throws IOException

Description copied from class: `ValueInstantiator`
Method called to create value instance from JSON Object when instantiation arguments are passed; this is done, for example when passing information specified with "Creator" annotations.

This method is called if `ValueInstantiator.getFromObjectArguments(com.fasterxml.jackson.databind.DeserializationConfig)` returns a non-empty List of arguments.

Overrides:
  `createFromObjectWith` in class `ValueInstantiator`
Throws:
  `IOException`

#### createFromObjectWith

    public Object createFromObjectWith(DeserializationContext ctxt,
                                       SettableBeanProperty[] props,
                                       PropertyValueBuffer buffer)
                                throws IOException

Description copied from class: `ValueInstantiator`
Method that delegates to `ValueInstantiator.createFromObjectWith(DeserializationContext, Object[])` by default, but can be overridden if the application should have customized behavior with respect to missing properties.

The default implementation of this method uses `PropertyValueBuffer.getParameters(SettableBeanProperty[])` to read and validate all properties in bulk, possibly substituting defaults for missing properties or throwing exceptions for missing properties. An overridden implementation of this method could, for example, use `PropertyValueBuffer.hasParameter(SettableBeanProperty)` and `PropertyValueBuffer.getParameter(SettableBeanProperty)` to safely read the present properties only, and to have some other behavior for the missing properties.

Overrides:
  `createFromObjectWith` in class `ValueInstantiator`
Throws:
  `IOException`

#### createUsingDelegate

    public Object createUsingDelegate(DeserializationContext ctxt,
                                      Object delegate)
                               throws IOException

Description copied from class: `ValueInstantiator`
Method to called to create value instance from JSON Object using an intermediate "delegate" value to pass to createor method

Overrides:
  `createUsingDelegate` in class `ValueInstantiator`
Throws:
  `IOException`

#### createUsingArrayDelegate

    public Object createUsingArrayDelegate(DeserializationContext ctxt,
                                           Object delegate)
                                    throws IOException

Description copied from class: `ValueInstantiator`
Method to called to create value instance from JSON Array using an intermediate "delegate" value to pass to createor method

Overrides:
  `createUsingArrayDelegate` in class `ValueInstantiator`
Throws:
  `IOException`

#### createFromString

    public Object createFromString(DeserializationContext ctxt,
                                   String value)
                            throws IOException

Overrides:
  `createFromString` in class `ValueInstantiator`
Throws:
  `IOException`

#### createFromInt

    public Object createFromInt(DeserializationContext ctxt,
                                int value)
                         throws IOException

Overrides:
  `createFromInt` in class `ValueInstantiator`
Throws:
  `IOException`

#### createFromLong

    public Object createFromLong(DeserializationContext ctxt,
                                 long value)
                          throws IOException

Overrides:
  `createFromLong` in class `ValueInstantiator`
Throws:
  `IOException`

#### createFromBigInteger

    public Object createFromBigInteger(DeserializationContext ctxt,
                                       BigInteger value)
                                throws IOException

Overrides:
  `createFromBigInteger` in class `ValueInstantiator`
Throws:
  `IOException`

#### createFromDouble

    public Object createFromDouble(DeserializationContext ctxt,
                                   double value)
                            throws IOException

Overrides:
  `createFromDouble` in class `ValueInstantiator`
Throws:
  `IOException`

#### createFromBigDecimal

    public Object createFromBigDecimal(DeserializationContext ctxt,
                                       BigDecimal value)
                                throws IOException

Overrides:
  `createFromBigDecimal` in class `ValueInstantiator`
Throws:
  `IOException`

#### createFromBoolean

    public Object createFromBoolean(DeserializationContext ctxt,
                                    boolean value)
                             throws IOException

Overrides:
  `createFromBoolean` in class `ValueInstantiator`
Throws:
  `IOException`

#### getDefaultCreator

    public AnnotatedWithParams getDefaultCreator()

Description copied from class: `ValueInstantiator`
Method that can be called to try to access member (constructor, static factory method) that is used as the "default creator" (creator that is called without arguments; typically default [zero-argument] constructor of the type). Note that implementations not required to return actual object they use (or, they may use some other instantiation) method. That is, even if `ValueInstantiator.canCreateUsingDefault()` returns true, this method may return null .

Overrides:
  `getDefaultCreator` in class `ValueInstantiator`

#### getDelegateCreator

    public AnnotatedWithParams getDelegateCreator()

Description copied from class: `ValueInstantiator`
Method that can be called to try to access member (constructor, static factory method) that is used as the "delegate creator". Note that implementations not required to return actual object they use (or, they may use some other instantiation) method. That is, even if `ValueInstantiator.canCreateUsingDelegate()` returns true, this method may return null .

Overrides:
  `getDelegateCreator` in class `ValueInstantiator`

#### getArrayDelegateCreator

    public AnnotatedWithParams getArrayDelegateCreator()

Description copied from class: `ValueInstantiator`
Method that can be called to try to access member (constructor, static factory method) that is used as the "array delegate creator". Note that implementations not required to return actual object they use (or, they may use some other instantiation) method. That is, even if `ValueInstantiator.canCreateUsingArrayDelegate()` returns true, this method may return null .

Overrides:
  `getArrayDelegateCreator` in class `ValueInstantiator`

#### getWithArgsCreator

    public AnnotatedWithParams getWithArgsCreator()

Description copied from class: `ValueInstantiator`
Method that can be called to try to access member (constructor, static factory method) that is used as the "non-default creator" (constructor or factory method that takes one or more arguments). Note that implementations not required to return actual object they use (or, they may use some other instantiation) method. That is, even if `ValueInstantiator.canCreateFromObjectWith()` returns true, this method may return null .

Overrides:
  `getWithArgsCreator` in class `ValueInstantiator`